//###################################################################################
// Datei: ftdi245.H
//
// Pindefinitionen fr FT245BM
//
// Last change: 03.02.2006
//###################################################################################
// Compiler AVR-GCC 3.4.3
//###################################################################################
// hk@holger-klabunde.de
// http://www.holger-klabunde.de
//###################################################################################

#include "mydefs.h"

#ifndef FTDI245_H
#define FTDI245_H

#define FTDI_IN()  	DDRA=0x00; // set io-pins to inputs
#define FTDI_OUT() 	DDRA=0xFF; // set io-pins to outputs
#define FTDI_READ()    	PINA	  // read PIN, ! NOT ! PORT
#define FTDI_WRITE(a)  	PORTA=(a); // write to data port

#define SIWU 		1	//Pin number for SIWU
#define SIWU_PORT 	PORTD   //Port where SIWU is located
#define SIWU_DDR 	DDRD   //Port where SIWU is located
#define RXF 		2	//Pin number for RXF
#define RXF_PORT 	PIND    //Port where RXF is located
#define RXF_DDR 	DDRD    //Port where RXF is located
#define TXE 		3 	//Pin number for TXE
#define TXE_PORT 	PIND    //Port where TXE is located
#define TXE_DDR 	DDRD    //Port where TXE is located
#define FTWR 		6	//Pin number for FTWR
#define FTWR_PORT 	PORTD    //Port where FTWR is located
#define FTWR_DDR 	DDRD    //Port where FTWR is located
#define FTRD 		7	//Pin number for FTRD
#define FTRD_PORT 	PORTD    //Port where FTRD is located
#define FTRD_DDR 	DDRD    //Port where FTRD is located

//Macro's
#define SIWU_ON() 	sbi(SIWU_PORT,SIWU);
#define SIWU_OFF() 	cbi(SIWU_PORT,SIWU);
#define RXF_OFF  	bit_is_clear(RXF_PORT,RXF)
#define RXF_ON   	bit_is_set(RXF_PORT,RXF)
#define TXE_OFF  	bit_is_clear(TXE_PORT,TXE)
#define TXE_ON   	bit_is_set(TXE_PORT,TXE)
#define FTWR_ON() 	sbi(FTWR_PORT,FTWR);
#define FTWR_OFF() 	cbi(FTWR_PORT,FTWR);
#define FTRD_ON() 	sbi(FTRD_PORT,FTRD);
#define FTRD_OFF() 	cbi(FTRD_PORT,FTRD);

#ifdef FCPU4000000
//This is blocking !
//You have to wait one NOP() even @ 4MHz !
#define FTRead() { \
                  while(RXF_ON); \
                  FTRD_OFF(); \
                  NOP(); \
                  rxbyte=FTDI_READ(); \
                  FTRD_ON(); \
                 };
#endif

#ifdef FCPU8000000
//This is blocking !
#define FTRead() { \
                  while(RXF_ON); \
                  FTRD_OFF(); \
                  NOP(); \
                  rxbyte=FTDI_READ(); \
                  FTRD_ON(); \
                  NOP(); \
                 };
#endif

#ifdef FCPU16000000
//This is blocking !
//You have to wait two NOP() @ 16MHz !
#define FTRead() { \
                  while(RXF_ON); \
                  FTRD_OFF(); \
                  NOP(); \
                  NOP(); \
                  rxbyte=FTDI_READ(); \
                  FTRD_ON(); \
                  NOP(); \
                  NOP(); \
                 };
#endif

//Prototypes
extern unsigned char rxbyte;
extern void FTWrite(unsigned char tx);
extern void FTDIInit(void);
//extern unsigned char FTRead(void);

#endif //FT245_H
