//###################################################################################
// Datei: MYDEFS.H
//
// Standarddefinitionen
//
// Last change: 03.02.2006
//###################################################################################
// Compiler AVR-GCC 3.4.3
//###################################################################################


#ifndef MYDEFS_H
#define MYDEFS_H

//#define FCPU4000000
//#define FCPU8000000
#define FCPU16000000

#define NOP() asm volatile ("nop" ::)

//WinAVR 3.4.3 setzt die Bitsetzbefehle sbi(),cbi() ins Assembler-Listing fr diese
//beiden #defines ein ! Also kein Grund Inline Assembler zu benutzen.
#define sbi(portn, bitn) ((portn)|=(1<<(bitn)))
#define cbi(portn, bitn) ((portn)&=~(1<<(bitn)))
//#define sbi(portn, bitn) asm volatile("sbi %0, %1" : : "I" (_SFR_IO_ADDR(portn)), "I" ((uint8_t)(bitn)))
//#define cbi(portn, bitn) asm volatile("cbi %0, %1" : : "I" (_SFR_IO_ADDR(portn)), "I" ((uint8_t)(bitn)))

//Die beiden LED's
#define GREEN	6
#define RED 	7

#define RED_ON() { cbi(PORTE,RED); }
#define RED_OFF() { sbi(PORTE,RED); }

#define GREEN_ON() { cbi(PORTE,GREEN); }
#define GREEN_OFF() { sbi(PORTE,GREEN); }

//Display commands
#define CLEAR_SCREEN		0xB0
#define SET_CURSOR		0xB1
#define CURSOR_HOME		0xB2
#define SET_CONTRAST		0xB3 //0..255, 0=off
#define SET_LIGHT		0xB4 //0..255, 0=off
#define SET_CGCHAR		0xB5 //0..31
// 0xB6 //free
#define SET_GFX			0xB7 //Set pixel array, 6 or 8 pixel at once
#define CLEAR_TEXT		0xB8 //Clear text screen, not used
#define CLEAR_GFX		0xB9 //Clear graphics screen, not used
#define SET_GFXBUFFER		0xBA //Set buffered pixel arrays, 6 or 8 pixel at once
#define SET_BITMAP		0xBB //Receive a bitmap. Each row can contain up to 255 bytes
#define LAST_COMMAND		0xBF

// State declarations for ProcessIo() states in user.c
#define NO_STATE		0
#define STATE_COMMAND		1
#define STATE_GETBITMAP_X	25 //0..255 X start position for the rows
#define STATE_GFXBUFFER_FILL    26
#define STATE_GETBITMAP_GETROW	29 //get data for this row
#define STATE_GETBITMAP_FULLSCREEN	30 //get a whole screen bitmap !

#endif //MYDEFS_H
